# your_Agents.py
# ---------
# COSC4550/COSC5550
# Artificial Intelligence
# University of Wyoming
# ---------
# Most code was part of the Pacman AI projects by John DeNero and Dan Klein
# Code has been modified for the Cleaning Agents AI Challenge by Joost Huizinga
# Licensing Information: Please do not distribute or publish solutions to this
# project. You are free to use and extend these projects for educational
# purposes. The Pacman AI projects were developed at UC Berkeley, primarily by
# John DeNero (denero@cs.berkeley.edu) and Dan Klein (klein@cs.berkeley.edu).
# For more info, see http://inst.eecs.berkeley.edu/~cs188/sp09/pacman.html

"""
This file contains all of the agents that can be selected to 
control our cleaner robot.  To select an agent, use the '-p' option
when running cleaner.py. 

Please only change the parts of the file you are asked to.
Look for the lines that say

# YOUR CODE HERE #

Good luck!
"""
from game import Directions
from game import Agent
from game import RobotActions
from game import Grid
from sets import Set
import util
import time
import random

class BasicAgent(Agent):
  "An agent that goes Forward until it can't, and then turns in a random direction."
  def getAction(self, state):
    "The agent receives an AgentState (defined in game.py)."
    if state.frontWallSensor == 1:
      if random.random() < 0.5:
        action = RobotActions.TURN_AND_MOVE_LEFT
      else:
        action = RobotActions.TURN_AND_MOVE_RIGHT
    else:
      action = RobotActions.FORWARD

    return action

class SimpleReflexAgent(Agent):
  "A reflex agent you have to implement"
  
  def getAction(self, state):
    "The agent receives an AgentState (defined in game.py)."
    # YOUR CODE HERE #
    util.raiseNotDefined()
    return action

class ModelBasedReflexAgent(Agent):
  "A reflex agent you have to implement"
  def __init__(self):
    # YOUR CODE HERE #
    util.raiseNotDefined()

  def getAction(self, state):
    "The agent receives an AgentState (defined in game.py)."
    # YOUR CODE HERE #
    util.raiseNotDefined()
    return action